﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {

  using Base.Erc;

  using Stack;

  public interface IReadOnlyPushConfiguration : IReadOnlyExpressionsConfiguration {
    int EvalPushLimit { get; }
    int MaxDepth { get; }
    int MaxStringLength { get; }
    int MaxVectorLength { get; }
    int MaxProgramLength { get; }
    int MaxPointsInRandomExpression { get; }
    bool TopLevelPushCode { get; }
    bool TopLevelPopCode { get; }
    int MaxClose { get; }
    double CloseBiasLevel { get; }
    IReadOnlyErcOptions ErcOptions { get; }
    string FloatStringFormat { get; }
    bool TopLevelPushInputArguments { get; }

    bool IsStackEnabled(StackTypes stackType);
  }
}
